
typedef int8_t  i8;
typedef int16_t i16;
typedef uint8_t  u8;
typedef uint16_t u16;


// There is an vsync-irq handler in ray.asm  The _enable_vsync_counter activates that handler and it stores its counter in _ticks
extern void _enable_vsync_counter(void);
extern u8 _ticks;
extern u16 _cycle_start;
extern u16 _cycle_end;
extern u8 _banked_ram[8096];
extern u8 _RAM_BANK;

// This is for calling the draw_vertical_bar funcion in assembly
extern void _init_draw_code(void);
extern void _generate_texture_draw_code(void);
extern void _draw_vertical_bar(void);
extern u16 _pixel_column;
extern u8 _capped_wall_height;
extern u16 _wall_height;
extern u8 _color_to_draw;
extern u8 _sub_bank;
extern u8 _use_textures;
#pragma zpsym ("_pixel_column")
#pragma zpsym ("_capped_wall_height")
#pragma zpsym ("_wall_height")
#pragma zpsym ("_color_to_draw")
#pragma zpsym ("_sub_bank")
#pragma zpsym ("_use_textures")

extern void _raycast_and_draw(void);
extern u16 _sin_player_dir;
extern u16 _cos_player_dir;
extern u16 _player_pos_x;
extern u16 _player_pos_y;
extern i16 _start_ray_dir_index; // We make this signed in c, so we can easely check if its negative
#pragma zpsym ("_sin_player_dir")
#pragma zpsym ("_cos_player_dir")
#pragma zpsym ("_player_pos_x")
#pragma zpsym ("_player_pos_y")
#pragma zpsym ("_start_ray_dir_index")

extern void _prepare_single_raycast(void);
extern void _cast_ray_dda_qdrt0(void);
extern u16 _sin_player_dir_local;
extern u16 _cos_player_dir_local;
extern u16 _player_pos_x_local;
extern u16 _player_pos_y_local;
extern u8 _x_tile;
extern u8 _y_tile;
extern u8 _minus_dx;
extern u8 _minus_dy;
extern u16 _ray_dir_index;
extern u16 _x_step;
extern u16 _y_step;
extern u16 _x_intercept;
extern u16 _y_intercept;
extern u8 _tile_value;
extern u16 _total_delta_x;
extern u16 _total_delta_y;
extern u16 _distance_to_wall;
extern u8 _hit_point_on_wall;
extern u8 _hit_vertical_wall;
#pragma zpsym ("_sin_player_dir_local")
#pragma zpsym ("_cos_player_dir_local")
#pragma zpsym ("_player_pos_x_local")
#pragma zpsym ("_player_pos_y_local")
#pragma zpsym ("_x_tile")
#pragma zpsym ("_y_tile")
// #pragma zpsym ("_minus_dx")
// #pragma zpsym ("_minus_dy")
#pragma zpsym ("_ray_dir_index")
#pragma zpsym ("_x_step")
#pragma zpsym ("_y_step")
#pragma zpsym ("_x_intercept")
#pragma zpsym ("_y_intercept")
#pragma zpsym ("_tile_value")
#pragma zpsym ("_total_delta_x")
#pragma zpsym ("_total_delta_y")
#pragma zpsym ("_distance_to_wall")
#pragma zpsym ("_hit_point_on_wall")
#pragma zpsym ("_hit_vertical_wall")

#define MAP_WIDTH_MAX 16
#define MAP_HEIGHT_MAX 16
extern u8 _world_map_q0[]; // This is placed at a certain memory address that is aligned to 256 bytes (in asm)
extern u8 _world_map_q1[]; // This is placed at a certain memory address that is aligned to 256 bytes (in asm)
extern u8 _world_map_q2[]; // This is placed at a certain memory address that is aligned to 256 bytes (in asm)
extern u8 _world_map_q3[]; // This is placed at a certain memory address that is aligned to 256 bytes (in asm)

extern u16 _world_map; // This should contain the address of the current (copy of the) ) world_map_qx used.
#pragma zpsym ("_world_map")


/*
// See: https://github.com/commanderx16/x16-demo/blob/master/cc65-sprite/demo.c

Python script to generate the table:
import math
# cycle=320
cycle=1824
ampl=256
[int(math.sin(float(i)/cycle*2.0*math.pi)*ampl+0.5) for i in range(cycle)]
[int(math.cos(float(i)/cycle*2.0*math.pi)*ampl+0.5) for i in range(cycle)]

[int(math.tan(float(i)/cycle*2.0*math.pi)*ampl+0.5) for i in range(cycle)]
[int((1/math.tan(float(i)/cycle*2.0*math.pi))*ampl+0.5) if (math.tan(float(i)/cycle*2.0*math.pi) != 0) else 9999999999 for i in range(cycle)]

*/
// Also see: https://csdb.dk/forums/?roomid=11&topicid=26608&firstpost=2

extern i16 _sin[] = {
     0, 1, 2, 3, 4, 4, 5, 6, 7, 8, 9, 10, 11, 11, 12, 13, 14, 15, 16, 17, 18, 19, 19, 20, 21, 22, 23, 24, 25, 26, 26, 27, 28, 29, 30, 31, 32, 33, 33, 34, 35, 36, 37, 38, 39, 40, 40, 41, 42, 43, 44, 45, 46, 46, 47, 48, 49, 50, 51, 52, 53, 53, 54, 55, 56, 57, 58, 59, 59, 60, 61, 62, 63, 64, 65, 65, 66, 67, 68, 69, 70, 71, 71, 72, 73, 74, 75, 76, 76, 77, 78, 79, 80, 81, 81, 82, 83, 84, 85, 86, 86, 87, 88, 89, 90, 91, 91, 92, 93, 94, 95, 96, 96, 97, 98, 99, 100, 100, 101, 102, 103, 104, 104, 105, 106, 107, 108, 108, 109, 110, 111, 112, 112, 113, 114, 115, 116, 116, 117, 118, 119, 120, 120, 121, 122, 123, 123, 124, 125, 126, 126, 127, 128, 129, 130, 130, 131, 132, 133, 133, 134, 135, 136, 136, 137, 138, 139, 139, 140, 141, 141, 142, 143, 144, 144, 145, 146, 147, 147, 148, 149, 149, 150, 151, 152, 152, 153, 154, 154, 155, 156, 157, 157, 158, 159, 159, 160, 161, 161, 162, 163, 163, 164, 165, 165, 166, 167, 167, 168, 169, 169, 170, 171, 171, 172, 173, 173, 174, 175, 175, 176, 177, 177, 178, 179, 179, 180, 180, 181, 182, 182, 183, 183, 184, 185, 185, 186, 187, 187, 188, 188, 189, 190, 190, 191, 191, 192, 192, 193, 194, 194, 195, 195, 196, 196, 197, 198, 198, 199, 199, 200, 200, 201, 201, 202, 203, 203, 204, 204, 205, 205, 206, 206, 207, 207, 208, 208, 209, 209, 210, 210, 211, 211, 212, 212, 213, 213, 214, 214, 215, 215, 216, 216, 217, 217, 218, 218, 219, 219, 219, 220, 220, 221, 221, 222, 222, 223, 223, 223, 224, 224, 225, 225, 226, 226, 226, 227, 227, 228, 228, 228, 229, 229, 230, 230, 230, 231, 231, 232, 232, 232, 233, 233, 233, 234, 234, 234, 235, 235, 235, 236, 236, 237, 237, 237, 238, 238, 238, 238, 239, 239, 239, 240, 240, 240, 241, 241, 241, 242, 242, 242, 242, 243, 243, 243, 244, 244, 244, 244, 245, 245, 245, 245, 246, 246, 246, 246, 247, 247, 247, 247, 248, 248, 248, 248, 248, 249, 249, 249, 249, 249, 250, 250, 250, 250, 250, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 255
};

i16 sine(i16 angle_index) {
    if (angle_index >= 0 && angle_index <= NR_OF_ANGLES/4) { // North East
        return _sin[angle_index];
    }
    else if (angle_index > NR_OF_ANGLES / 4 && angle_index <= NR_OF_ANGLES / 2) { // North West
        return _sin[NR_OF_ANGLES/2 - angle_index];
    }
    else if (angle_index > NR_OF_ANGLES / 2 && angle_index < (NR_OF_ANGLES / 4) * 3) { // South West
        return -_sin[angle_index - NR_OF_ANGLES / 2];
    }
    else if (angle_index >= (NR_OF_ANGLES / 4) * 3 && (angle_index < NR_OF_ANGLES)) { // South East
        return -_sin[NR_OF_ANGLES/2 - (angle_index - (NR_OF_ANGLES / 2))];
    }
    else {
        // FIXME: show the error!!
        printf("invalid angle_index!!\n");
        //return MAX_I16;
        while(1);
    }
}

extern i16 _cos[] = {
    256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 254, 254, 254, 254, 254, 254, 254, 254, 254, 253, 253, 253, 253, 253, 253, 253, 253, 252, 252, 252, 252, 252, 252, 251, 251, 251, 251, 251, 251, 250, 250, 250, 250, 250, 249, 249, 249, 249, 249, 248, 248, 248, 248, 248, 247, 247, 247, 247, 246, 246, 246, 246, 245, 245, 245, 245, 244, 244, 244, 244, 243, 243, 243, 242, 242, 242, 242, 241, 241, 241, 240, 240, 240, 239, 239, 239, 238, 238, 238, 238, 237, 237, 237, 236, 236, 235, 235, 235, 234, 234, 234, 233, 233, 233, 232, 232, 232, 231, 231, 230, 230, 230, 229, 229, 228, 228, 228, 227, 227, 226, 226, 226, 225, 225, 224, 224, 223, 223, 223, 222, 222, 221, 221, 220, 220, 219, 219, 219, 218, 218, 217, 217, 216, 216, 215, 215, 214, 214, 213, 213, 212, 212, 211, 211, 210, 210, 209, 209, 208, 208, 207, 207, 206, 206, 205, 205, 204, 204, 203, 203, 202, 201, 201, 200, 200, 199, 199, 198, 198, 197, 196, 196, 195, 195, 194, 194, 193, 192, 192, 191, 191, 190, 190, 189, 188, 188, 187, 187, 186, 185, 185, 184, 183, 183, 182, 182, 181, 180, 180, 179, 179, 178, 177, 177, 176, 175, 175, 174, 173, 173, 172, 171, 171, 170, 169, 169, 168, 167, 167, 166, 165, 165, 164, 163, 163, 162, 161, 161, 160, 159, 159, 158, 157, 157, 156, 155, 154, 154, 153, 152, 152, 151, 150, 149, 149, 148, 147, 147, 146, 145, 144, 144, 143, 142, 141, 141, 140, 139, 139, 138, 137, 136, 136, 135, 134, 133, 133, 132, 131, 130, 130, 129, 128, 127, 126, 126, 125, 124, 123, 123, 122, 121, 120, 120, 119, 118, 117, 116, 116, 115, 114, 113, 112, 112, 111, 110, 109, 108, 108, 107, 106, 105, 104, 104, 103, 102, 101, 100, 100, 99, 98, 97, 96, 96, 95, 94, 93, 92, 91, 91, 90, 89, 88, 87, 86, 86, 85, 84, 83, 82, 81, 81, 80, 79, 78, 77, 76, 76, 75, 74, 73, 72, 71, 71, 70, 69, 68, 67, 66, 65, 65, 64, 63, 62, 61, 60, 59, 59, 58, 57, 56, 55, 54, 53, 53, 52, 51, 50, 49, 48, 47, 46, 46, 45, 44, 43, 42, 41, 40, 40, 39, 38, 37, 36, 35, 34, 33, 33, 32, 31, 30, 29, 28, 27, 26, 26, 25, 24, 23, 22, 21, 20, 19, 19, 18, 17, 16, 15, 14, 13, 12, 11, 11, 10, 9, 8, 7, 6, 5, 4, 4, 3, 2, 1, 0, 0
};

i16 cosine(i16 angle_index) {
    if (angle_index >= 0 && angle_index <= NR_OF_ANGLES/4) { // North East
        return _cos[angle_index];
    }
    else if (angle_index > NR_OF_ANGLES / 4 && angle_index <= NR_OF_ANGLES / 2) { // North West
        return -_cos[NR_OF_ANGLES/2 - angle_index];
    }
    else if (angle_index > NR_OF_ANGLES / 2 && angle_index < (NR_OF_ANGLES / 4) * 3) { // South West
        return -_cos[angle_index - NR_OF_ANGLES / 2];
    }
    else if (angle_index >= (NR_OF_ANGLES / 4) * 3 && (angle_index < NR_OF_ANGLES)) { // South East
        return _cos[NR_OF_ANGLES/2 - (angle_index - (NR_OF_ANGLES / 2))];
    }
    else {
        // FIXME: show the error!!
        printf("invalid angle_index!!\n");
        //return MAX_I16;
        while(1);
    }
}

#define MAX_I16 32767
#define MIN_I16 -32767 // TODO: 'Warning: Integer constant is long'

// TODO: we could combine invtan and tan into one table (maybe by accessing it with TOTAL_ANGLES - angle_index - TOTAL_ANGLES/4 ?)

extern i16 _tan[] = {
    0, 1, 2, 3, 4, 4, 5, 6, 7, 8, 9, 10, 11, 11, 12, 13, 14, 15, 16, 17, 18, 19, 19, 20, 21, 22, 23, 24, 25, 26, 27, 27, 28, 29, 30, 31, 32, 33, 34, 35, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 117, 118, 119, 120, 121, 122, 123, 124, 125, 126, 127, 128, 130, 131, 132, 133, 134, 135, 136, 137, 139, 140, 141, 142, 143, 144, 145, 147, 148, 149, 150, 151, 153, 154, 155, 156, 157, 159, 160, 161, 162, 164, 165, 166, 167, 169, 170, 171, 172, 174, 175, 176, 178, 179, 180, 181, 183, 184, 185, 187, 188, 190, 191, 192, 194, 195, 196, 198, 199, 201, 202, 204, 205, 206, 208, 209, 211, 212, 214, 215, 217, 218, 220, 221, 223, 225, 226, 228, 229, 231, 232, 234, 236, 237, 239, 241, 242, 244, 246, 247, 249, 251, 252, 254, 256, 258, 260, 261, 263, 265, 267, 269, 271, 272, 274, 276, 278, 280, 282, 284, 286, 288, 290, 292, 294, 296, 298, 300, 302, 304, 307, 309, 311, 313, 315, 317, 320, 322, 324, 327, 329, 331, 334, 336, 338, 341, 343, 346, 348, 351, 353, 356, 359, 361, 364, 367, 369, 372, 375, 377, 380, 383, 386, 389, 392, 395, 398, 401, 404, 407, 410, 413, 416, 420, 423, 426, 430, 433, 436, 440, 443, 447, 451, 454, 458, 462, 465, 469, 473, 477, 481, 485, 489, 493, 497, 502, 506, 510, 515, 519, 524, 528, 533, 538, 542, 547, 552, 557, 562, 568, 573, 578, 584, 589, 595, 600, 606, 612, 618, 624, 630, 637, 643, 649, 656, 663, 670, 677, 684, 691, 698, 706, 714, 721, 729, 737, 746, 754, 763, 772, 781, 790, 799, 809, 818, 828, 839, 849, 860, 871, 882, 894, 905, 917, 930, 942, 955, 969, 982, 996, 1011, 1026, 1041, 1057, 1073, 1089, 1107, 1124, 1142, 1161, 1180, 1200, 1221, 1242, 1264, 1287, 1311, 1335, 1360, 1387, 1414, 1442, 1472, 1502, 1534, 1567, 1602, 1638, 1676, 1716, 1757, 1801, 1846, 1894, 1945, 1998, 2054, 2113, 2176, 2242, 2313, 2388, 2468, 2554, 2646, 2745, 2851, 2965, 3089, 3224, 3372, 3533, 3710, 3906, 4123, 4367, 4640, 4950, 5304, 5713, 6190, 6753, 7429, 8255, 9287, 10615, 12384, 14862, 18578, 24771, MAX_I16/2, MAX_I16/2, MAX_I16/2
};

/*
i16 tangent(i16 angle_index) {
    if (angle_index >= 0 && angle_index <= NR_OF_ANGLES/4) { // North East
        return _tan[angle_index];
    }
    else if (angle_index > NR_OF_ANGLES / 4 && angle_index <= NR_OF_ANGLES / 2) { // North West
        return -_tan[NR_OF_ANGLES/2 - angle_index];
    }
    else if (angle_index > NR_OF_ANGLES / 2 && angle_index < (NR_OF_ANGLES / 4) * 3) { // South West
        return _tan[angle_index - NR_OF_ANGLES / 2];
    }
    else if (angle_index >= (NR_OF_ANGLES / 4) * 3 && (angle_index < NR_OF_ANGLES)) { // South East
        return -_tan[NR_OF_ANGLES/2 - (angle_index - (NR_OF_ANGLES / 2))];
    }
    else {
        // FIXME: show the error!!
        printf("invalid angle_index!!\n");
        //return MAX_I16;
        while(1);
    }
}
*/

extern i16 _invtan[] = {
    MAX_I16/2, MAX_I16/2, MAX_I16/2, 24771, 18578, 14862, 12384, 10615, 9287, 8255, 7429, 6753, 6190, 5713, 5304, 4950, 4640, 4367, 4123, 3906, 3710, 3533, 3372, 3224, 3089, 2965, 2851, 2745, 2646, 2554, 2468, 2388, 2313, 2242, 2176, 2113, 2054, 1998, 1945, 1894, 1846, 1801, 1757, 1716, 1676, 1638, 1602, 1567, 1534, 1502, 1472, 1442, 1414, 1387, 1360, 1335, 1311, 1287, 1264, 1242, 1221, 1200, 1180, 1161, 1142, 1124, 1107, 1089, 1073, 1057, 1041, 1026, 1011, 996, 982, 969, 955, 942, 930, 917, 905, 894, 882, 871, 860, 849, 839, 828, 818, 809, 799, 790, 781, 772, 763, 754, 746, 737, 729, 721, 714, 706, 698, 691, 684, 677, 670, 663, 656, 649, 643, 637, 630, 624, 618, 612, 606, 600, 595, 589, 584, 578, 573, 568, 562, 557, 552, 547, 542, 538, 533, 528, 524, 519, 515, 510, 506, 502, 497, 493, 489, 485, 481, 477, 473, 469, 465, 462, 458, 454, 451, 447, 443, 440, 436, 433, 430, 426, 423, 420, 416, 413, 410, 407, 404, 401, 398, 395, 392, 389, 386, 383, 380, 377, 375, 372, 369, 367, 364, 361, 359, 356, 353, 351, 348, 346, 343, 341, 338, 336, 334, 331, 329, 327, 324, 322, 320, 317, 315, 313, 311, 309, 307, 304, 302, 300, 298, 296, 294, 292, 290, 288, 286, 284, 282, 280, 278, 276, 274, 272, 271, 269, 267, 265, 263, 261, 260, 258, 256, 254, 252, 251, 249, 247, 246, 244, 242, 241, 239, 237, 236, 234, 232, 231, 229, 228, 226, 225, 223, 221, 220, 218, 217, 215, 214, 212, 211, 209, 208, 206, 205, 204, 202, 201, 199, 198, 196, 195, 194, 192, 191, 190, 188, 187, 185, 184, 183, 181, 180, 179, 178, 176, 175, 174, 172, 171, 170, 169, 167, 166, 165, 164, 162, 161, 160, 159, 157, 156, 155, 154, 153, 151, 150, 149, 148, 147, 145, 144, 143, 142, 141, 140, 139, 137, 136, 135, 134, 133, 132, 131, 130, 128, 127, 126, 125, 124, 123, 122, 121, 120, 119, 118, 117, 115, 114, 113, 112, 111, 110, 109, 108, 107, 106, 105, 104, 103, 102, 101, 100, 99, 98, 97, 96, 95, 94, 93, 92, 91, 90, 89, 88, 87, 86, 85, 84, 83, 82, 81, 80, 79, 78, 77, 76, 75, 74, 73, 72, 71, 70, 70, 69, 68, 67, 66, 65, 64, 63, 62, 61, 60, 59, 58, 57, 56, 56, 55, 54, 53, 52, 51, 50, 49, 48, 47, 46, 45, 45, 44, 43, 42, 41, 40, 39, 38, 37, 36, 35, 35, 34, 33, 32, 31, 30, 29, 28, 27, 27, 26, 25, 24, 23, 22, 21, 20, 19, 19, 18, 17, 16, 15, 14, 13, 12, 11, 11, 10, 9, 8, 7, 6, 5, 4, 4, 3, 2, 1, 0, 0
};
/*
i16 invtangent(i16 angle_index) {
    if (angle_index >= 0 && angle_index <= NR_OF_ANGLES/4) { // North East
        return _invtan[angle_index];
    }
    else if (angle_index > NR_OF_ANGLES / 4 && angle_index <= NR_OF_ANGLES / 2) { // North West
        return -_invtan[NR_OF_ANGLES/2 - angle_index];
    }
    else if (angle_index > NR_OF_ANGLES / 2 && angle_index < (NR_OF_ANGLES / 4) * 3) { // South West
        return _invtan[angle_index - NR_OF_ANGLES / 2];
    }
    else if (angle_index >= (NR_OF_ANGLES / 4) * 3 && (angle_index < NR_OF_ANGLES)) { // South East
        return -_invtan[NR_OF_ANGLES/2 - (angle_index - (NR_OF_ANGLES / 2))];
    }
    else {
        // FIXME: show the error!!
        printf("invalid angle_index!!\n");
        //return MAX_I16;
        while(1);
    }
}
*/

u8 position_is_wall(i16 ray_point_x, i16 ray_point_y);
u8 position_is_walkable(i16 pos_x, i16 pos_y);
void copy_world_map_to_four_quadrants();
u16 get_distance_to_wall_dda_asm(u16 player_pos_x, u16 player_pos_y, i16 ray_dir_index, i16 sin_player_dir, i16 cos_player_dir);
//u16 get_distance_to_wall_dda(u16 player_pos_x, u16 player_pos_y, i16 ray_dir_index, i16 sin_player_dir, i16 cos_player_dir, u8 do_print);
//u16 get_distance_to_wall(u16 player_pos_x, u16 player_pos_y, u16 ray_dir_index);
//i16 multiply_with_fraction (i16 number, i16 fraction);
void load_file_into_banked_ram(char * file_name);

void create_new_palette();
void make_layer_1_transparent ();
void draw_text(char * text, u16 x, u16 y, u8 color);
void set_character_tile_at_xy(u8 character, u16 x, u16 y);
void set_character_at_xy(u8 character, u16 x, u16 y, u8 color);
void set_palette_color(u8 index, u8 red, u8 green, u8 blue);
void generate_render_code();
u8 pick_texture_pixel_row(u16 point_on_capped_height, u16 capped_height, u16 height);
void draw_vertical_bar(u16 x_start, u16 height, u8 color);
void move_text_screen_in_memory();
void enable_display_layer(u8 layer);
void disable_display_layer(u8 layer);
void copy_texture_to_vram (u8 texture_index);
void draw_progress_bar_border ();
void draw_progress_piece (u16 progress_index);
void clear_screen ();
void clear_render_area ();
void init_draw_screen();
void draw_background (u8 background_color, u8 stats_background_color);
void print_vera_info();
u8 display_layer_is_enabled(u8 layer);

