; Used for vsync-counter
.export __enable_vsync_counter
.export __ticks

.export __cycle_start
.export __cycle_end
__cycle_start:    .word 0
__cycle_end:      .word 0
CLOCK_CYCLE     = $9FB8

.macro START_CLOCK
    lda CLOCK_CYCLE
    sta __cycle_start
    lda CLOCK_CYCLE+1
    sta __cycle_start+1
.endmacro
.macro END_CLOCK
    lda CLOCK_CYCLE
    sta __cycle_end
    lda CLOCK_CYCLE+1
    sta __cycle_end+1
.endmacro

; Used for draw_vertical_bar
.export __init_draw_code
.export __generate_texture_draw_code
.export __draw_vertical_bar
.export __pixel_column
.export __capped_wall_height
.export __wall_height
.export __color_to_draw
.export __RAM_BANK
.export __banked_ram
.export __sub_bank
.export __use_textures

; Used for raycast_and_draw
.export __raycast_and_draw
.export __start_ray_dir_index
.export __player_pos_x
.export __player_pos_y
.export __sin_player_dir
.export __cos_player_dir

.export __prepare_single_raycast
; User for cast_ray_dda_qdrt0
.export __cast_ray_dda_qdrt0
.export __sin_player_dir_local
.export __cos_player_dir_local
.export __player_pos_x_local
.export __player_pos_y_local
.export __x_tile
.export __y_tile
.export __minus_dx
.export __minus_dy
.export __ray_dir_index
.export __x_step
.export __y_step
.export __x_intercept
.export __y_intercept
.export __tile_value
.export __total_delta_x
.export __total_delta_y
.export __distance_to_wall
.export __hit_point_on_wall
.export __hit_vertical_wall

.import __tan
.import __invtan
.import __sin
.import __cos
.export __world_map
.export __world_map_q0
.export __world_map_q1
.export __world_map_q2
.export __world_map_q3

; General X16 addresses
IRQVec            = $0314
VERA_addr_low	  = $9F20
VERA_addr_high	  = $9F21
VERA_addr_bank	  = $9F22
VERA_data0		  = $9F23
VERA_data1		  = $9F24
VERA_control	  = $9F25
VERA_ien          = $9F26
VERA_isr          = $9F27

__RAM_BANK        = $9F61
ZP_PTR_1          = $00	; NOTE: we can't use this, is for memory banking!!
ZP_PTR_2          = $22
ZP_PTR_3          = $24
ZP_PTR_4          = $26 ; NOTE: we use this, but always make a backup and restore that (since the c program is using it)
ZP_PTR_4_BACKUP:  .addr 0

VSYNC_BIT         = $01

; Demo specific settings
CEILING_COLOR     = 19
FLOOR_COLOR       = 22

SCREEN_HEIGHT     = 240
RENDER_HEIGHT     = 152+30
SCREEN_WIDTH      = 320
RENDER_WIDTH      = 304
RENDER_BASE       = $6000+4*320+8 ; We have a top border of 4 pixels, so we add it to the TILE_BASE. We also have a left border of 8 pixel so we add that too
NR_OF_ANGLES      = 6*RENDER_WIDTH
TEXTURES_VRAM_BASE = $8C00

; Used for raycast_and_draw
__sin_player_dir =      $38 ; word
__cos_player_dir =      $3A ; word
__player_pos_x =        $3C ; word
__player_pos_y =        $3E ; word
remainder =             $74 ; word   ; REUSED!
dividend =              $76 ; word   ; REUSED!
divisor =               $78 ; word   ; REUSED!
divresult =             dividend
WALL_HEIGHT_NUMERATOR = 8500

; Set BEFORE calling cast rays
__sin_player_dir_local = $40 ; word
__cos_player_dir_local = $42 ; word
; Cast ray dda qdrt0,1,2,3 ---
__player_pos_x_local =  $44 ; word
__player_pos_y_local =  $46 ; word
__minus_dx:            .byte 0 ; byte
__x_tile =              $49 ; byte
__minus_dy:            .byte 0 ; byte
__y_tile =              $4B ; byte  
__ray_dir_index =       $4C ; word
__start_ray_dir_index = $4E ; word
__x_step =              $50 ; word
__y_step =              $52 ; word
__x_intercept =         $54 ; word
__y_intercept =         $56 ; word
__total_delta_x =       $58 ; word
__total_delta_y =       $5A ; word
__distance_to_wall =    $5C ; word
__tile_value =          $5E ; byte
__hit_point_on_wall =   $5F ; byte
__hit_vertical_wall =   $60 ; byte
just_travelled =        $61 ; byte

fraction =              $73 ; byte
low_bits =              $74 ; byte   ; REUSED!
high_bits =             $75 ; byte   ; REUSED!
do_negate_cos_player_dir = $48 ; byte
do_negate_sin_player_dir = $4A ; byte
multiplied_low_bits =   $78 ; word   ; REUSED!
multiplied_high_bits =  $7A ; word

; --- Draw Verical Bar ---
__pixel_column =        $62 ; word
__capped_wall_height =  $64 ; word ; Note that we really only use the high byte for capping
__wall_height =         $66 ; word
__color_to_draw =       $68 ; byte
__sub_bank =            $69 ; byte
__use_textures =        $6A ; byte

ceiling_height =        $6B ; byte
ceiling_hi =            $6C ; byte
ceiling_low =           $6D ; byte
wall_hi =               $6E ; byte
wall_low =              $6F ; byte
floor_height =          $70 ; byte
floor_hi =              $71 ; byte
floor_low =             $72 ; byte

jump_address =          $7E ; addr

__banked_ram        = $A000
__banked_draw_code  = $A000 ; 1024 bytes
__banked_draw_code1 = $A400 ; 1024 bytes
__banked_draw_code2 = $A800 ; 1024 bytes
__banked_draw_code3 = $AC00 ; 1024 bytes
__banked_draw_code4 = $B000 ; 1024 bytes
__banked_draw_code5 = $B400 ; 1024 bytes
__banked_draw_code6 = $B800 ; 1024 bytes
__banked_draw_code7 = $BC00 ; 1024 bytes

; TODO: We don't really need this many instructions for drawing vertical pixels (now we do 240, but we only need RENDER_HEIGHT amount of pixels)
draw_240_pixels         = $8900 ; TODO: is this a safe place to put our generated code? --> we need around $0300 bytes (a little less)
distance2height0_LO     = $8C00  ; 512 * 3 = 256 * 6
distance2height0_HI     = $8D00  
distance2height0_Capped = $8E00
distance2height1_LO     = $8F00
distance2height1_HI     = $9000
distance2height1_Capped = $9100
square1_lo              = $9200
square1_hi              = $9400
square2_lo              = $9600
square2_hi              = $9800
__world_map_q0          = $9A00
__world_map_q1          = $9B00
__world_map_q2          = $9C00
__world_map_q3          = $9D00
__world_map             = $7C ; word
MAP_WIDTH_MAX      = 16
MAP_HEIGHT_MAX     = 16

.macro DivideWordBy8 word_to_divide
    lsr word_to_divide+1
    ror word_to_divide
    lsr word_to_divide+1
    ror word_to_divide
    lsr word_to_divide+1
    ror word_to_divide
.endmacro

.macro MultiplyWordBy64 word_to_multiply
    asl word_to_multiply
    rol word_to_multiply+1
    asl word_to_multiply
    rol word_to_multiply+1
    asl word_to_multiply
    rol word_to_multiply+1
    asl word_to_multiply
    rol word_to_multiply+1
    asl word_to_multiply
    rol word_to_multiply+1
    asl word_to_multiply
    rol word_to_multiply+1
.endmacro

.macro SubtractWordFromWord first_word, second_word, result_word
    lda first_word
    sec
    sbc second_word
    sta result_word
    lda first_word+1
    sbc second_word+1
    sta result_word+1
.endmacro

.macro SubtractByteFromByte first_byte, second_byte, result_byte
    lda first_byte
    sec
    sbc second_byte
    sta result_byte
.endmacro

.macro AddWordToWord first_word, second_word, result_word
    clc
    lda first_word
    adc second_word
    sta result_word   ; store sum of LSBs
    lda first_word+1
    adc second_word+1  ; add the MSBs using carry from the previous calculation
    sta result_word+1
.endmacro

.macro AddByteToByteIntoWord first_byte, second_byte, result_word
    clc
    lda first_byte
    adc second_byte
    sta result_word   ; store sum of LSBs
    lda #0
    bcc :+            ; if carry was clear we do not add anything (high byte is 0)
    inc               ; add carry from the previous calculation if it was set
:
    sta result_word+1
.endmacro

.macro CopyWord from_word, to_word
    lda from_word
    sta to_word
    lda from_word+1
    sta to_word+1
.endmacro

.macro LoadWord VALUE, word_to_load
    lda #<VALUE
    sta word_to_load
    lda #>VALUE
    sta word_to_load+1
.endmacro

.macro CapWordTo511 word_to_cap
    lda word_to_cap+1
    cmp #2
    bcc :+   ; if the high byte of the word is smaller than 2 then we are below 512 so we don't need to cap
    lda #1
    sta word_to_cap+1
    lda #255
    sta word_to_cap
:        
.endmacro

.macro CapWordToConstantByte word_to_cap, CONSTANT_BYTE
    lda word_to_cap+1
    cmp #1
    bcc :+           ; if word_to_cap (high) is smaller than 1, we don't know yet for sure we have to cap it, we have to check the low byte
    lda #0           ; if it was 1 or higher, we have to cap it
    sta word_to_cap+1
    lda #CONSTANT_BYTE
    sta word_to_cap
    bra :++
:
    lda word_to_cap
    cmp #CONSTANT_BYTE+1
    bcc :+           ; if word_to_cap (low byte) is smaller than CONSTANT_BYTE+1 then we don't have to cap it
    lda #CONSTANT_BYTE
    sta word_to_cap
:
.endmacro

.macro DecrementPixelColumnAndMaybeStopCasting
    lda __pixel_column
    cmp #0
    bne :+               ; If __pixel_column (low byte) is 0, we should decrement the high byte as well (if not zero, then we should skip doing that)
    dec __pixel_column+1
    bpl :+               ; If __pixel_column (low byte) is 0 and high byte is 0 (so its negative after decrementing) we should stop casting
    jmp stop_casting
:    
    dec __pixel_column
.endmacro
    
.macro IncrementWord word_to_increment
    inc word_to_increment   ; we increment word_to_increment (low byte)
    bne :+
    inc word_to_increment+1 ; if word_to_increment has reached #00 we increment the high byte as well
:    
.endmacro

.macro NegateWord word_to_negate, negated_word
    sec			         ; set carry for borrow purpose
    lda #0
    sbc word_to_negate   ; perform subtraction on the LSBs
    sta negated_word
    lda #0
    sbc word_to_negate+1 ; do the same for the MSBs, with carry set according to the previous result
    sta negated_word+1
.endmacro

.macro DetermineCosineNegation
    ldy#0
    lda __cos_player_dir_local+1 ; high byte
    bpl :+ ; if __cos_player_dir_local is negative we negate it (also: if its negative, it can't be 256 so we don't have to check that here)
    ldy #1
:    
    sty do_negate_cos_player_dir
    
    lda __cos_player_dir_local
    cpy #1 ; FIXME: we already know its 1 (see above) can we do this more efficiently?
    bne :+
    eor #$FF
    inc  ; I *believe* this works and ignores the carry flag.
:
        sta C_sm1a+1
        sta C_sm3a+1
        sta C_sm5a+1
        sta C_sm7a+1
        eor #$ff
        sta C_sm2a+1
        sta C_sm4a+1
        sta C_sm6a+1
        sta C_sm8a+1
.endmacro

.macro DetermineSineNegation
    ldy#0
    lda __sin_player_dir_local+1 ; high byte
    bpl :+ ; if __sin_player_dir_local is negative we negate it (also: if its negative, it can't be 256 so we don't have to check that here)
    ldy #1
:    
    sty do_negate_sin_player_dir
    
    lda __sin_player_dir_local
    cpy #1 ; FIXME: we already know its 1 (see above) can we do this more efficiently?
    bne :+
    eor #$FF
    inc  ; I *believe* this works and ignores the carry flag.
:
        sta S_sm1a+1
        sta S_sm3a+1
        sta S_sm5a+1
        sta S_sm7a+1
        eor #$ff
        sta S_sm2a+1
        sta S_sm4a+1
        sta S_sm6a+1
        sta S_sm8a+1
.endmacro

.macro PrepareMinusDyMultiplication
;    sta __minus_dy              ; minus_dy = 255 - player_pos_y (low byte) 
        sta X_sm1a+1
        sta X_sm3a+1
        sta X_sm5a+1
        sta X_sm7a+1
        eor #$ff
        sta X_sm2a+1
        sta X_sm4a+1
        sta X_sm6a+1
        sta X_sm8a+1
.endmacro

.macro PrepareMinusDxMultiplication
;    sta __minus_dx              ; minus_dx = 255 - player_pos_x (low byte) 
        sta Y_sm1a+1
        sta Y_sm3a+1
        sta Y_sm5a+1
        sta Y_sm7a+1
        eor #$ff
        sta Y_sm2a+1
        sta Y_sm4a+1
        sta Y_sm6a+1
        sta Y_sm8a+1
.endmacro
        
; We have to do this only from c, in order to call __cast_ray_dda_qdrt0
__prepare_single_raycast:

    lda __minus_dx
    sta Y_sm1a+1
    sta Y_sm3a+1
    sta Y_sm5a+1
    sta Y_sm7a+1
    eor #$ff
    sta Y_sm2a+1
    sta Y_sm4a+1
    sta Y_sm6a+1
    sta Y_sm8a+1
    
    lda __minus_dy    
    sta X_sm1a+1
    sta X_sm3a+1
    sta X_sm5a+1
    sta X_sm7a+1
    eor #$ff
    sta X_sm2a+1
    sta X_sm4a+1
    sta X_sm6a+1
    sta X_sm8a+1
    
    DetermineCosineNegation
    DetermineSineNegation
    rts


; ================================================================================================
; =================================== RAYCAST AND DRAW ===========================================
; ================================================================================================
__raycast_and_draw:

    ; ========= STARTUP: check where to begin casting and jump to appriate place in big loop ====
    
    ; We start at pixel column RENDER_WIDTH-1
    lda #<(RENDER_WIDTH-1)
    sta __pixel_column
    lda #>(RENDER_WIDTH-1)
    sta __pixel_column+1

    lda __start_ray_dir_index+1
    ldx __start_ray_dir_index
    
    cmp #1
    bcc q0_0_to_455_jmp ; if high byte is smaller than 1 (so its equals to 0) then we should jump to the section q0_0_to_455
    bne :+              ; if high byte is not equal to 1 (so its higher than 1) then we should go to a higher quarter
    cpx #200
    bcc q0_0_to_455_jmp ; if low byte is smaller than 200 (and the high byte is 1, meaning < 256+200=456) then we should jump to the q0 section
    jmp q1_455_to_0     ; if low byte >= 200 (and high byte is 1) then we should jump to the q1 section
:   
    cmp #3
    bcc q1_455_to_0_jmp ; if high byte is smaller than 3 we should jump to the q1 section
    bne :+              ; if high byte is not equal to 3 (so its higher than 3) then we should go to a higher quarter
    cpx #144
    bcc q1_455_to_0_jmp ; if low byte is smaller than 144 (and the high byte is 3, meaning < 3*256+144=912) then we should jump to the q1 section
    jmp q2_0_to_455     ; if low byte >= 144 (and high byte is 3) then we should jump to the q2 section
:
    cmp #5
    bcc q2_0_to_455_jmp ; if high byte is smaller than 5 we should jump to the q2 section
    bne :+              ; if high byte is not equal to 5 (so its higher than 5) then we should go to a higher quarter
    cpx #88
    bcc q2_0_to_455_jmp ; if low byte is smaller than 88 (and the high byte is 3, meaning < 5*256+88=1368) then we should jump to the q2 section
:
    jmp q3_455_to_0
    
    rts ; will never be reached (rts is after where we jumped to)
    
; Jumping area
q0_0_to_455_jmp:
    jmp q0_0_to_455
q1_455_to_0_jmp:
    jmp q1_455_to_0
q2_0_to_455_jmp:
    jmp q2_0_to_455
    

; ==================================================== Quarter 0 =======================================================    

q0_0_to_455:
    lda __player_pos_x+1
    sta __player_pos_x_local+1  ; player_pos_x_local = player_pos_x (high byte)
    
    lda __player_pos_y+1
    sta __player_pos_y_local+1  ; player_pos_y_local = player_pos_y (high byte)
    
    lda __player_pos_x
    sta __player_pos_x_local    ; player_pos_x_local = player_pos_x (low byte)    
    
    lda #255
    sec
    sbc __player_pos_x
    PrepareMinusDxMultiplication
    
    lda __player_pos_y
    sta __player_pos_y_local    ; player_pos_y_local = player_pos_y (low byte) 
    
    lda #255
    sec
    sbc __player_pos_y
    PrepareMinusDyMultiplication
    
    lda #<__world_map_q0
    sta __world_map
    lda #>__world_map_q0
    sta __world_map+1

    CopyWord __cos_player_dir, __cos_player_dir_local
    DetermineCosineNegation
    CopyWord __sin_player_dir, __sin_player_dir_local
    DetermineSineNegation
    
q0_0_to_455_local:

    ; TODO: should we rename __ray_dir_index to   __local_ray_dir_index ?
    CopyWord __start_ray_dir_index, __ray_dir_index
    
q0_0_to_455_local_loop:

        ; FIXME: we reload these since they are changed by the __cast_ray_dda_qdrt0 function
        lda __player_pos_x_local+1
        sta __x_tile
        lda __player_pos_y_local+1
        sta __y_tile

        jsr __cast_ray_dda_qdrt0
       
        ;  wall_height = WALL_HEIGHT_NUMERATOR / (normalized_distance_to_wall / 8); // This is square!

;START_CLOCK
;        LoadWord WALL_HEIGHT_NUMERATOR, dividend
        CopyWord __distance_to_wall, divisor
        DivideWordBy8 divisor  ; dividing the distance_to_wall by 8
        
        ldx divisor
        lda divisor+1
        bne :+
        
        lda distance2height0_HI,x
        sta __wall_height+1
        lda distance2height0_LO,x
        sta __wall_height
        lda distance2height0_Capped,x
        sta __capped_wall_height
        bra :++
:
        lda distance2height1_HI,x
        sta __wall_height+1
        lda distance2height1_LO,x
        sta __wall_height
        lda distance2height1_Capped,x
        sta __capped_wall_height
:        
        ; we need to preserve the non-capped height (for textures)
;        CopyWord divresult, __wall_height
;        CopyWord divresult, __capped_wall_height
        
        ; Capped height to 511 is used to determinign which precomputed code has to be run (if height is larger than render height, pixels have to be "stretched")
;        CapWordTo511 __wall_height

        ; Capped height to RENDER_HEIGHT is used for determining how many ceiling/floor pixels have to be drawn
;        CapWordToConstantByte __capped_wall_height, RENDER_HEIGHT
;END_CLOCK
        
        ; TODO: this only allows for specific colors
        lda __tile_value
        sta __color_to_draw
        
        ; We draw the vertical bar
        jsr __draw_vertical_bar
    
        DecrementPixelColumnAndMaybeStopCasting
        IncrementWord __start_ray_dir_index
        
        IncrementWord __ray_dir_index
        
        lda __ray_dir_index+1
        beq :+                ; if high byte is 0, we still have to loop
        lda __ray_dir_index
        cmp #200              
        beq :++               ; if high byte > 0 (==1) and low byte is 200, we stop looping
:
    jmp q0_0_to_455_local_loop
:    
    
; ==================================================== Quarter 1 =======================================================    
    
q1_455_to_0:

    lda #MAP_WIDTH_MAX-1
    sec
    sbc __player_pos_x+1
    sta __player_pos_x_local+1  ; player_pos_x_local = MAP_WIDTH_MAX-1 - player_pos_x (high byte)
    
    lda __player_pos_y+1
    sta __player_pos_y_local+1  ; player_pos_y_local = player_pos_y (high byte)
    
    lda #255
    sec
    sbc __player_pos_x
    sta __player_pos_x_local    ; player_pos_x_local = 255 - player_pos_x (low byte) 
    
    lda __player_pos_x
    PrepareMinusDxMultiplication
    
    lda __player_pos_y
    sta __player_pos_y_local    ; player_pos_y_local = player_pos_y (low byte) 
    
    lda #255
    sec
    sbc __player_pos_y
    PrepareMinusDyMultiplication
    
    lda #<__world_map_q1
    sta __world_map
    lda #>__world_map_q1
    sta __world_map+1
    
    NegateWord __cos_player_dir, __cos_player_dir_local
    DetermineCosineNegation
    CopyWord __sin_player_dir, __sin_player_dir_local
    DetermineSineNegation

q1_455_to_0_local:

    lda #<(NR_OF_ANGLES/2)
    sec
    sbc __start_ray_dir_index
    sta __ray_dir_index
    lda #>(NR_OF_ANGLES/2)
    sbc __start_ray_dir_index+1
    sta __ray_dir_index+1          ; ray_dir_index = NR_OF_ANGLES/2 - start_ray_dir_index

q1_455_to_0_local_loop:

        ; FIXME: we reload these since they are changed by the __cast_ray_dda_qdrt0 function
        lda __player_pos_x_local+1
        sta __x_tile        
        lda __player_pos_y_local+1
        sta __y_tile

        jsr __cast_ray_dda_qdrt0
       
        ;  wall_height = WALL_HEIGHT_NUMERATOR / (normalized_distance_to_wall / 8); // Walls look squarish this way!

;        LoadWord WALL_HEIGHT_NUMERATOR, dividend
        CopyWord __distance_to_wall, divisor
        DivideWordBy8 divisor  ; dividing the distance_to_wall by 8
        
        ldx divisor
        lda divisor+1
        bne :+
        
        lda distance2height0_HI,x
        sta __wall_height+1
        lda distance2height0_LO,x
        sta __wall_height
        lda distance2height0_Capped,x
        sta __capped_wall_height
        bra :++
:
        lda distance2height1_HI,x
        sta __wall_height+1
        lda distance2height1_LO,x
        sta __wall_height
        lda distance2height1_Capped,x
        sta __capped_wall_height
:        
        ; FIXME: this should be put inline using a macro! Do not copy all these 16-bit values!
;        jsr divide

        ; we need to preserve the non-capped height (for textures)
;        CopyWord divresult, __wall_height
;        CopyWord divresult, __capped_wall_height
        
        ; Capped height to 511 is used to determinign which precomputed code has to be run (if height is larger than render height, pixels have to be "stretched")
;        CapWordTo511 __wall_height

        ; Capped height to RENDER_HEIGHT is used for determining how many ceiling/floor pixels have to be drawn
;        CapWordToConstantByte __capped_wall_height, RENDER_HEIGHT
        
        ; TODO: this only allows for specific colors
        lda __tile_value
        sta __color_to_draw
        
        ; We have to determine if we have to flip hit_point_on_wall (if we hit a horizontal wall, we should)
        lda __hit_vertical_wall
        bne :+                  ; if vertical then don't flip
        lda #255
        sec 
        sbc __hit_point_on_wall
        sta __hit_point_on_wall
:
        ; We draw the vertical bar
        jsr __draw_vertical_bar
    
        DecrementPixelColumnAndMaybeStopCasting
        IncrementWord __start_ray_dir_index
        
        lda __ray_dir_index
        cmp #0
        bne :+               ; If __ray_dir_index (low byte) is 0, we should decrement the high byte as well (if not zero, then we should skip doing that)
        dec __ray_dir_index+1
        bmi :++               ; If __ray_dir_index (low byte) is 0 and high byte is 0 (so its negative after decrementing) we should stop looping in this quarter
:
        dec __ray_dir_index  ; decrement low byte
        
    jmp q1_455_to_0_local_loop
:    

; ==================================================== Quarter 2 =======================================================    
    
q2_0_to_455:

    lda #MAP_WIDTH_MAX-1
    sec
    sbc __player_pos_x+1
    sta __player_pos_x_local+1  ; player_pos_x_local = MAP_WIDTH_MAX-1 - player_pos_x (high byte)

    lda #MAP_HEIGHT_MAX-1
    sec
    sbc __player_pos_y+1
    sta __player_pos_y_local+1  ; player_pos_y_local = MAP_HEIGHT_MAX-1 - player_pos_y (high byte)
    
    lda #255
    sec
    sbc __player_pos_x
    sta __player_pos_x_local    ; player_pos_x_local = 255 - player_pos_x (low byte) 
    
    lda __player_pos_x
    PrepareMinusDxMultiplication
    
    lda #255
    sec
    sbc __player_pos_y
    sta __player_pos_y_local    ; player_pos_y_local = 255 - player_pos_y (low byte) 

    lda __player_pos_y
    PrepareMinusDyMultiplication
    
    lda #<__world_map_q2
    sta __world_map
    lda #>__world_map_q2
    sta __world_map+1
    
    NegateWord __cos_player_dir, __cos_player_dir_local
    DetermineCosineNegation
    NegateWord __sin_player_dir, __sin_player_dir_local
    DetermineSineNegation

q2_0_to_455_local:

    lda __start_ray_dir_index
    sec
    sbc #<(NR_OF_ANGLES/2)
    sta __ray_dir_index
    lda __start_ray_dir_index+1
    sbc #>(NR_OF_ANGLES/2)
    sta __ray_dir_index+1          ; ray_dir_index = start_ray_dir_index - NR_OF_ANGLES/2

q2_0_to_455_local_loop:

        ; FIXME: we reload these since they are changed by the __cast_ray_dda_qdrt0 function
        lda __player_pos_x_local+1
        sta __x_tile
        lda __player_pos_y_local+1
        sta __y_tile

        jsr __cast_ray_dda_qdrt0
       
        ;  wall_height = WALL_HEIGHT_NUMERATOR / (normalized_distance_to_wall / 8); // This is square!

;        LoadWord WALL_HEIGHT_NUMERATOR, dividend
        CopyWord __distance_to_wall, divisor
        DivideWordBy8 divisor  ; dividing the distance_to_wall by 8
        
        ldx divisor
        lda divisor+1
        bne :+
        
        lda distance2height0_HI,x
        sta __wall_height+1
        lda distance2height0_LO,x
        sta __wall_height
        lda distance2height0_Capped,x
        sta __capped_wall_height
        bra :++
:
        lda distance2height1_HI,x
        sta __wall_height+1
        lda distance2height1_LO,x
        sta __wall_height
        lda distance2height1_Capped,x
        sta __capped_wall_height
:        
        ; FIXME: this should be put inline using a macro! Do not copy all these 16-bit values!
;        jsr divide

        ; we need to preserve the non-capped height (for textures)
;        CopyWord divresult, __wall_height
;        CopyWord divresult, __capped_wall_height
        
        ; Capped height to 511 is used to determinign which precomputed code has to be run (if height is larger than render height, pixels have to be "stretched")
;        CapWordTo511 __wall_height

        ; Capped height to RENDER_HEIGHT is used for determining how many ceiling/floor pixels have to be drawn
;        CapWordToConstantByte __capped_wall_height, RENDER_HEIGHT
        
        ; TODO: this only allows for specific colors
        lda __tile_value
        sta __color_to_draw
        
        ; We always flip hit_point_on_wall, since we are in q2
        lda #255
        sec 
        sbc __hit_point_on_wall
        sta __hit_point_on_wall

        ; We draw the vertical bar
        jsr __draw_vertical_bar
    
        DecrementPixelColumnAndMaybeStopCasting
        IncrementWord __start_ray_dir_index
        
        IncrementWord __ray_dir_index
        
        lda __ray_dir_index+1
        beq :+                ; if high byte is 0, we still have to loop
        lda __ray_dir_index
        cmp #200              
        beq :++               ; if high byte > 0 (==1) and low byte is 200, we stop looping
:
    jmp q2_0_to_455_local_loop
:    

; ==================================================== Quarter 3 =======================================================    
    
q3_455_to_0:

    lda __player_pos_x+1
    sta __player_pos_x_local+1  ; player_pos_x_local = player_pos_x (high byte)
    
    lda #MAP_HEIGHT_MAX-1
    sec
    sbc __player_pos_y+1
    sta __player_pos_y_local+1  ; player_pos_y_local = MAP_HEIGHT_MAX-1 - player_pos_y (high byte)

    
    lda __player_pos_x
    sta __player_pos_x_local    ; player_pos_x_local = player_pos_x (low byte)    
    
    lda #255
    sec
    sbc __player_pos_x
    PrepareMinusDxMultiplication
    
    lda #255
    sec
    sbc __player_pos_y
    sta __player_pos_y_local    ; player_pos_y_local = 255 - player_pos_y (low byte) 

    lda __player_pos_y
    PrepareMinusDyMultiplication
    
    
    lda #<__world_map_q3
    sta __world_map
    lda #>__world_map_q3
    sta __world_map+1
    
    CopyWord __cos_player_dir, __cos_player_dir_local
    DetermineCosineNegation
    NegateWord __sin_player_dir, __sin_player_dir_local
    DetermineSineNegation

q3_455_to_0_local:

    lda #<NR_OF_ANGLES
    sec
    sbc __start_ray_dir_index
    sta __ray_dir_index
    lda #>NR_OF_ANGLES
    sbc __start_ray_dir_index+1
    sta __ray_dir_index+1          ; ray_dir_index = NR_OF_ANGLES - start_ray_dir_index

q3_455_to_0_local_loop:

        ; FIXME: we reload these since they are changed by the __cast_ray_dda_qdrt0 function
        lda __player_pos_x_local+1
        sta __x_tile        
        lda __player_pos_y_local+1
        sta __y_tile

        jsr __cast_ray_dda_qdrt0
       
        ;  wall_height = WALL_HEIGHT_NUMERATOR / (normalized_distance_to_wall / 8); // This is square!

;        LoadWord WALL_HEIGHT_NUMERATOR, dividend
        CopyWord __distance_to_wall, divisor
        DivideWordBy8 divisor  ; dividing the distance_to_wall by 8
        
        ldx divisor
        lda divisor+1
        bne :+
        
        lda distance2height0_HI,x
        sta __wall_height+1
        lda distance2height0_LO,x
        sta __wall_height
        lda distance2height0_Capped,x
        sta __capped_wall_height
        bra :++
:
        lda distance2height1_HI,x
        sta __wall_height+1
        lda distance2height1_LO,x
        sta __wall_height
        lda distance2height1_Capped,x
        sta __capped_wall_height
:        
        ; FIXME: this should be put inline using a macro! Do not copy all these 16-bit values!
;        jsr divide

        ; we need to preserve the non-capped height (for textures)
;        CopyWord divresult, __wall_height
;        CopyWord divresult, __capped_wall_height
        
        ; Capped height to 511 is used to determinign which precomputed code has to be run (if height is larger than render height, pixels have to be "stretched")
;        CapWordTo511 __wall_height

        ; Capped height to RENDER_HEIGHT is used for determining how many ceiling/floor pixels have to be drawn
;        CapWordToConstantByte __capped_wall_height, RENDER_HEIGHT
        
        ; TODO: this only allows for specific colors
        lda __tile_value
        sta __color_to_draw
        
        ; We have to determine if we have to flip hit_point_on_wall (if we hit a vertical wall, we should)
        lda __hit_vertical_wall
        beq :+                  ; if horizontal then don't flip
        lda #255
        sec 
        sbc __hit_point_on_wall
        sta __hit_point_on_wall
:
        ; We draw the vertical bar
        jsr __draw_vertical_bar
    
        DecrementPixelColumnAndMaybeStopCasting
        IncrementWord __start_ray_dir_index
        
        lda __ray_dir_index
        cmp #0
        bne :+               ; If __ray_dir_index (low byte) is 0, we should decrement the high byte as well (if not zero, then we should skip doing that)
        dec __ray_dir_index+1
        bmi :++               ; If __ray_dir_index (low byte) is 0 and high byte is 0 (so its negative after decrementing) we should stop looping in this quarter
:
        dec __ray_dir_index  ; decrement low byte
        
    jmp q3_455_to_0_local_loop
:    

    ; __start_ray_dir_index > NR_OF_ANGLES, so we should substract NR_OF_ANGLES, starting at q0 again

    lda __start_ray_dir_index
    sec
    sbc #<NR_OF_ANGLES
    sta __start_ray_dir_index
    lda __start_ray_dir_index+1
    sbc #>NR_OF_ANGLES
    sta __start_ray_dir_index+1          ; __start_ray_dir_index = __start_ray_dir_index - NR_OF_ANGLES
    
    ; looping back to q0
    jmp q0_0_to_455 

stop_casting:

    rts


; https://codebase64.org/doku.php?id=base:16bit_division_16-bit_result
divide:
	lda #0	        ;preset remainder to 0
	sta remainder
	sta remainder+1
	ldx #16	        ;repeat for each bit: ...

divloop:
	asl dividend	;dividend lb & hb*2, msb -> Carry
	rol dividend+1	
	rol remainder	;remainder lb & hb * 2 + msb from carry
	rol remainder+1
	lda remainder
	sec
	sbc divisor	;substract divisor to see if it fits in
	tay	        ;lb result -> Y, for we may need it later
	lda remainder+1
	sbc divisor+1
	bcc skip	;if carry=0 then divisor didn't fit in yet

	sta remainder+1	;else save substraction result as new remainder,
	sty remainder	
	inc divresult	;and INCrement result cause divisor fit in 1 times

skip:
	dex
	bne divloop	
	rts



; ================================================================================================
; ==================================== CAST RAY (DDA) ============================================
; ================================================================================================

; arguments:
; __tile_x (is changed by the function!)
; __tile_y (is changed by the function!)
; __player_pos_x_local
; __player_pos_y_local
; __ray_dir_index
; __world_map
; also uses:
; __x_intercept (local)
; __y_intercept (local)
; __x_step (local)
; __y_step (local)
; __minus_dy (local)
; __minus_dx (local)
; fraction (local)
; multiplied_high_bits (local)
; multiplied_low_bits (local)
; just_travelled (local)
; __tan     (global)
; __invtan  (global)
__cast_ray_dda_qdrt0:

    ; FIXME: we should also set player_pos_x, player_pos_y, cos_player_dir, sin_player_dir. 
    ; BUT we should do this only ONCE per frame (not each time we call this function!

    
    ; ==== Calculatin x_step and y_step using tan[] and invtan[] ====
    
    ; x_step = invtangent(ray_dir_index);
    ; y_step = tangent(ray_dir_index);
        
    lda __ray_dir_index   ; low byte
    asl                   ; shift low byte to the left once (*2) and set carry bit accordingly
    tax                   ; put low*2 in x
    
    lda __ray_dir_index+1 ; hi byte
    rol                   ; shift high to the left once (*2) and use carry of shift of low as bit 0

    ; TODO: maybe use smaller than/greater than (PLUS or NEGATIVE) for a faster 'binary search' of the 4 segments
    
    ; Compare the HI * 2 with 0, 1, 2 or 3
    cmp #1
    beq tan_1
    cmp #2
    beq tan_2
    cmp #3
    beq tan_3
    
tan_0:                 ; ray indexes: 0-127
    lda __tan+0,x
    sta __y_step
    lda __invtan+0,x
    sta __x_step
    inx
    lda __tan+0,x
    sta __y_step+1
    lda __invtan+0,x
    sta __x_step+1
    bra done_tan
    
tan_1:                 ; ray indexes: 128-255
    lda __tan+256,x
    sta __y_step
    lda __invtan+256,x
    sta __x_step
    inx
    lda __tan+256,x
    sta __y_step+1
    lda __invtan+256,x
    sta __x_step+1
    bra done_tan
    
tan_2:                 ; ray indexes: 256-383
    lda __tan+512,x
    sta __y_step
    lda __invtan+512,x
    sta __x_step
    inx
    lda __tan+512,x
    sta __y_step+1
    lda __invtan+512,x
    sta __x_step+1
    bra done_tan
    
tan_3:                 ; ray indexes: 384-456  (one quadrant: 6 * 304 / 4 = 456 indexes)
    lda __tan+768,x
    sta __y_step
    lda __invtan+768,x
    sta __x_step
    inx
    lda __tan+768,x
    sta __y_step+1
    lda __invtan+768,x
    sta __x_step+1
    
done_tan:

    ; ==== Now we calculate the x_intercept and y_intercept ==== 
    
    ; x_intercept = player_pos_x + multiply_with_fraction(x_step, 255-dy);
    ; y_intercept = player_pos_y + multiply_with_fraction(y_step, 255-dx);
    
    ; Note that fraction cannot be 256 here, since dy is a number between 0 and 255
    ; If dy == 0 then we result is 0. Thats ok. It simply means that y will never change
    ; so we will never cross a horizontal line.
    
    ; -- mutliplying x_step with 255-dy --
    
        ; Perform 255-dy * __x_step = AAaa
        ldx __x_step
        sec
X_sm1a: lda square1_lo,x
X_sm2a: sbc square2_lo,x
; TODO: we don't need aa: sta multiplied_low_bits+0
X_sm3a: lda square1_hi,x
X_sm4a: sbc square2_hi,x
        sta X_AA+1

        ; Perform 255-dy * __x_step+1 = BBbb
        ldx __x_step+1
        sec
X_sm5a: lda square1_lo,x
X_sm6a: sbc square2_lo,x
        sta X_bb+1
X_sm7a: lda square1_hi,x
X_sm8a: sbc square2_hi,x
        sta X_BB+1

        ; Add the separate multiplications together
        clc
X_AA:   lda #0       ; AA = multiplied_low_bits+1
X_bb:   adc #0       ; bb = multiplied_high_bits
        sta multiplied_high_bits
; FIXME: can we remove the lda here and only do the adc?
X_BB:   lda #0       ; BB = multiplied_high_bits+1
        adc #0       ; no cc, so 0 (but we need to add the carry)
        sta multiplied_high_bits+1

    ; x_intercept = player_pos_x + multiply_with_fraction(x_step, 255-dy);

        clc
        lda multiplied_high_bits
        adc __player_pos_x_local
        sta __x_intercept   ; store sum of LSBs
        lda multiplied_high_bits+1
        adc __player_pos_x_local+1  ; add the MSBs using carry from the previous calculation
        sta __x_intercept+1


    ; Note that fraction cannot be 256 here, since dx is a number between 0 and 255
    ; If dx == 0 then we result is 0. Thats ok. It simply means that x will never change
    ; so we will never cross a vertical line.
    
    ; -- mutliplying y_step with 255-dx --
    
        ; Perform 255-dx * __y_step = AAaa
        ldx __y_step
        sec
Y_sm1a: lda square1_lo,x
Y_sm2a: sbc square2_lo,x
; TODO: we don't need aa: sta multiplied_low_bits+0
Y_sm3a: lda square1_hi,x
Y_sm4a: sbc square2_hi,x
        sta Y_AA+1

        ; Perform 255-dx * __y_step+1 = BBbb
        ldx __y_step+1
        sec
Y_sm5a: lda square1_lo,x
Y_sm6a: sbc square2_lo,x
        sta Y_bb+1
Y_sm7a: lda square1_hi,x
Y_sm8a: sbc square2_hi,x
        sta Y_BB+1

        ; Add the separate multiplications together
        clc
Y_AA:   lda #0       ; AA = multiplied_low_bits+1
Y_bb:   adc #0       ; bb = multiplied_high_bits
        sta multiplied_high_bits
; FIXME: can we remove the lda here and only do the adc?
Y_BB:   lda #0       ; BB = multiplied_high_bits+1
        adc #0       ; no cc, so 0 (but we need to add the carry)
        sta multiplied_high_bits+1

        ; y_intercept = player_pos_y + multiply_with_fraction(y_step, 255-dx);

        clc
        lda multiplied_high_bits
        adc __player_pos_y_local
        sta __y_intercept   ; store sum of LSBs
        lda multiplied_high_bits+1
        adc __player_pos_y_local+1  ; add the MSBs using carry from the previous calculation
        sta __y_intercept+1


    ; SOLUTION: we use just_travelled to remember whether we just travelled. If you travel in one direction and then we stop travelling in that direction, we assume you will ALWAYS travel at least once in the *other* direction.
    lda #0 ; 
    sta just_travelled ; "just travelled" = 0


    ; =============== X TRAVEL ================
   
try_x_travel_0:
    ; We check if we have to travel in the y-row
    
    ; while (y_intercept_HI <= y_tile+1) // As long as my yIntercept hasn't become bigger (=outside my y-row) than the y I am in (because then we have to move y)
    ; while (NOT (y_tile+1 < y_intercept_HI))
    lda __y_tile
    inc                    ; y_tile+1
    cmp __y_intercept+1    ; y_intercept high byte
    bmi stop_x_travel_0    ; if y_tile+1 < y_intercept_HI then we DONT loop here
    bne do_x_travel_0      ; if y_tile+1 != y_intercept_HI then: y_tile+1 > y_intercept_HI (so we can y-travel)
    lda __y_intercept      ; we know that y_tile+1 == y_intercept_HI, so we need to check whether y_intercept_LO is 0 or not
    cmp #0
    bne stop_x_travel_0    ; Since y_intercept_LO > 0, we know that y_tile+1 < y_intercept_HI + y_intercept_LO, so do *not* travel in x
    
    ; -- Do travel in x-row --
do_x_travel_0:
    ; tile_value = _world_map[y_tile*MAP_WIDTH_MAX+x_tile+tile_step_x];
    lda __y_tile
    asl
    asl
    asl
    asl            ; y_tile * 16
    clc 
    ; TODO: we should be sure x_tile is not bigger than 16
    adc __x_tile   ; y_tile * 16 + x_tile
    ; WARNING: we assume tile_step_x is 1 here!!
    inc            ; y_tile * 16 + x_tile + 1
    tay

    lda (__world_map), y
    cmp #0
    beq continue_x_travel_0
    
        ; We hit a vertical wall
        ; Storing tile_value
        sta __tile_value
        
        ; total_delta_x = (x_tile+tile_step_x)*256 - player_pos_x;

        sec			         ; set carry for borrow purpose
        lda #0               ; the lower byte of (x_tile+tile_step_x)*256 is 0
        sbc __player_pos_x_local   ; perform subtraction on the LSBs
        sta __total_delta_x
        lda __x_tile         ; We regards x_tile to be the MSB (in other words: we multiply it effectively with 256)
        ; WARNING: we assume tile_step_x is 1 here!!
        inc
        sbc __player_pos_x_local+1   ; do the same for the MSBs, with carry set according to the previous result
        sta __total_delta_x+1
    
        ; total_delta_y = y_intercept - player_pos_y;
        
        sec			         ; set carry for borrow purpose
        lda __y_intercept
        sbc __player_pos_y_local   ; perform subtraction on the LSBs
        sta __total_delta_y
        lda __y_intercept+1
        sbc __player_pos_y_local+1 ; do the same for the MSBs, with carry set according to the previous result
        sta __total_delta_y+1

        ; ========= calculate distance to wall ==========
        
        jsr calculate_distance_to_wall
        
        ; ========= hit point on wall ==========
        
        ; hit_point_on_wall = 255-y_intercept%256;
        
        sec
        lda #255
        sbc __y_intercept   ; low byte
        sta __hit_point_on_wall
        
        lda #1
        sta __hit_vertical_wall
        
        jmp wall_was_hit
    
    
continue_x_travel_0:

    ; =========== increment and continue to try x travel ==========

    ; x_tile += tile_step_x; // We step to the next x-tile
    
    ; WARNING: we are assuming that tile_step_x == +1
    inc __x_tile
    
    ; y_intercept += y_step; // the next intercept with the vertical bar will be y_step incremented

    clc
    lda __y_intercept
    adc __y_step
    sta __y_intercept   ; store sum of LSBs
    lda __y_intercept+1
    adc __y_step+1      ; add the MSBs using carry from the previous calculation
    sta __y_intercept+1
    
    ; SOLUTION: we just travelled in y. so we set "just travelled" to 1
    lda #1
    sta just_travelled
    
    bra try_x_travel_0

    
stop_x_travel_0:
    ; -- We ended searching in the y-row

    ; SOLUTION: we check if just_travelled == 1. If so we known we just travelled in x. So we have to travelle at least once in y. So be go to do_y_travel_0.
    lda just_travelled
    cmp #1
    lda #0
    sta just_travelled   ; We also reset just_travelled. Because y means "just travelled". We haven't travelled in y yet.
    beq do_y_travel_0


    ; =============== Y TRAVEL ================
    
try_y_travel_0:
    ; We check if we have to travel in the y-row
    
    ; while (x_intercept_HI <= x_tile+1) // As long as my xIntercept hasn't become bigger (outside my x-column) than the x I am in (because then we have to move x!)
    ; while (NOT (x_tile+1 < x_intercept_HI))
    lda __x_tile
    inc                   ; x_tile+1
    cmp __x_intercept+1   ; x_intercept high byte
    bmi stop_y_travel_0   ; if x_tile+1 < x_intercept_HI then we DONT loop here
    bne do_y_travel_0     ; if x_tile+1 != x_intercept_HI then: x_tile+1 > x_intercept_HI (so we can x-travel)
    lda __x_intercept      ; we know that x_tile+1 == x_intercept_HI, so we need to check whether x_intercept_LO is 0 or not
    cmp #0
    bne stop_y_travel_0    ; Since x_intercept_LO > 0, we know that x_tile+1 < x_intercept_HI + x_intercept_LO, so do *not* travel in y
    
    ; -- Do travel in y-column --
do_y_travel_0:
    ; tile_value = _world_map[(y_tile+tile_step_y)*MAP_WIDTH_MAX+x_tile];
    lda __y_tile
    ; WARNING: we assume tile_step_y is 1 here!!
    inc            ;  y_tile+1
    asl
    asl
    asl
    asl            ; (y_tile+1) * 16
    clc 
    ; TODO: we should be sure x_tile is not bigger than 16
    adc __x_tile   ; y_tile * 16 + x_tile
    tay

    lda (__world_map), y
    cmp #0
    beq continue_y_travel_0

        ; We hit a horizontal wall
        ; Storing tile_value
        sta __tile_value
        
        ; total_delta_x = x_intercept - player_pos_x;
   
        sec			         ; set carry for borrow purpose
        lda __x_intercept
        sbc __player_pos_x_local   ; perform subtraction on the LSBs
        sta __total_delta_x
        lda __x_intercept+1
        sbc __player_pos_x_local+1 ; do the same for the MSBs, with carry set according to the previous result
        sta __total_delta_x+1
        
        ; total_delta_y = (y_tile+tile_step_y)*256 - player_pos_y;
        
        sec			         ; set carry for borrow purpose
        lda #0               ; the lower byte of (y_tile+tile_step_y)*256 is 0
        sbc __player_pos_y_local   ; perform subtraction on the LSBs
        sta __total_delta_y
        lda __y_tile         ; We regards y_tile to be the MSB (in other words: we multiply it effectively with 256)
        ; WARNING: we assume tile_step_y is 1 here!!
        inc
        sbc __player_pos_y_local+1   ; do the same for the MSBs, with carry set according to the previous result
        sta __total_delta_y+1
        
        ; ========= calculate distance to wall ==========
        
        jsr calculate_distance_to_wall
        
        ; ========= hit point on wall ==========
        
        ; hit_point_on_wall = x_intercept%256;
        
        lda __x_intercept
        sta __hit_point_on_wall
    
        stz __hit_vertical_wall
        
        bra wall_was_hit

continue_y_travel_0:

    ; =========== increment and continue to try y travel ==========
    
    ; y_tile += tile_step_y; // We step to the next y-tile
    
    ; WARNING: we are assuming that tile_step_y == +1
    inc __y_tile
    
    ; x_intercept += x_step; // the next intercept with the horizontal bar will be x_step incremented
    
    clc
    lda __x_intercept
    adc __x_step
    sta __x_intercept   ; store sum of LSBs
    lda __x_intercept+1
    adc __x_step+1      ; add the MSBs using carry from the previous calculation
    sta __x_intercept+1
    
    ; SOLUTION: we just travelled in y. so we set "just travelled" to 1
    lda #1
    sta just_travelled
    
    bra try_y_travel_0
    
do_x_travel_0_jmp:
    jmp do_x_travel_0
    
stop_y_travel_0:
    ; -- We ended searching in the x-row
    
    ; SOLUTION: we check if just_travelled == 1. If so we known we just travelled in y. So we have to travel at least once in x. So be go to do_x_travel_0.
    lda just_travelled
    cmp #1
    lda #0   ; We also reset just_travelled. Because y means "just travelled". We haven't travelled in x yet.
    sta just_travelled
    beq do_x_travel_0_jmp

    ; looping back to begining of both while-loops
    jmp try_x_travel_0
  
wall_was_hit:
    rts


; ==================================== Calculate distance to wall ============================================

calculate_distance_to_wall:
    ; distance_to_wall = multiply_with_fraction(total_delta_x, cos_player_dir) + multiply_with_fraction(total_delta_y, sin_player_dir);

    ; negating an 8-bit number: https://wiki.nesdev.com/w/index.php/Synthetic_instructions
    
    lda __cos_player_dir_local+1 ; high byte
    cmp #1
    bne do_cos_multiply
    
    ; if cos is 256 (high byte == 1) then we don't need to multiply, we simply take the original value
    lda __total_delta_x
    sta __distance_to_wall
    lda __total_delta_x+1
    sta __distance_to_wall+1
    bra calculate_sin_part
    
    ; -- mutliplying total_delta_x with __cos_player_dir_local --
do_cos_multiply:

        ; Perform __cos_player_dir_local * total_delta_x = AAaa
        ldx __total_delta_x
        sec
C_sm1a: lda square1_lo,x
C_sm2a: sbc square2_lo,x
; TODO: we don't need aa: sta multiplied_low_bits+0
C_sm3a: lda square1_hi,x
C_sm4a: sbc square2_hi,x
        sta C_AA+1

        ; Perform __cos_player_dir_local * total_delta_x+1 = BBbb
        ldx __total_delta_x+1
        sec
C_sm5a: lda square1_lo,x
C_sm6a: sbc square2_lo,x
        sta C_bb+1
C_sm7a: lda square1_hi,x
C_sm8a: sbc square2_hi,x
        sta C_BB+1

        ; Add the separate multiplications together
        clc
C_AA:   lda #0       ; AA = multiplied_low_bits+1
C_bb:   adc #0       ; bb = multiplied_high_bits
        sta __distance_to_wall
; FIXME: can we remove the lda here and only do the adc?
C_BB:   lda #0       ; BB = multiplied_high_bits+1
        adc #0       ; no cc, so 0 (but we need to add the carry)
        sta __distance_to_wall+1

    ldy do_negate_cos_player_dir
    beq calculate_sin_part

    NegateWord __distance_to_wall, __distance_to_wall

calculate_sin_part:
    ; now we calculate the sin-part
    
;    ldy #0   ; by default we assume we don't have to negate the result from the sine multiplication

    lda __sin_player_dir_local+1 ; high byte
    cmp #1
    bne do_sin_multiply
    ; if sin is 256 (high byte == 1) then we don't need to multiply, we simply take the original value
    lda __total_delta_y
    sta multiplied_high_bits
    lda __total_delta_y+1
    sta multiplied_high_bits+1
    bra add_sin_part_to_distance
    
    ; -- mutliplying total_delta_y with __sin_player_dir_local --
do_sin_multiply:

        ; Perform __sin_player_dir_local * total_delta_y = AAaa
        ldx __total_delta_y
        sec
S_sm1a: lda square1_lo,x
S_sm2a: sbc square2_lo,x
; TODO: we don't need aa: sta multiplied_low_bits+0
S_sm3a: lda square1_hi,x
S_sm4a: sbc square2_hi,x
        sta S_AA+1

        ; Perform __sin_player_dir_local * total_delta_y+1 = BBbb
        ldx __total_delta_y+1
        sec
S_sm5a: lda square1_lo,x
S_sm6a: sbc square2_lo,x
        sta S_bb+1
S_sm7a: lda square1_hi,x
S_sm8a: sbc square2_hi,x
        sta S_BB+1

        ; Add the separate multiplications together
        clc
S_AA:   lda #0       ; AA = multiplied_low_bits+1
S_bb:   adc #0       ; bb = multiplied_high_bits
        sta multiplied_high_bits
; FIXME: can we remove the lda here and only do the adc?
S_BB:   lda #0       ; BB = multiplied_high_bits+1
        adc #0       ; no cc, so 0 (but we need to add the carry)
        sta multiplied_high_bits+1

    ldy do_negate_sin_player_dir    
    beq add_sin_part_to_distance

    ; __distance_to_wall = multiply_with_fraction(total_delta_x, cos_player_dir) - multiply_with_fraction(total_delta_y, -sin_player_dir);
    ; __distance_to_wall = __distance_to_wall - multiply_with_fraction(total_delta_y, -sin_player_dir);
    
    ; FIXME: is there a faster/better way of negating a 16-bit number?
    sec			         ; set carry for borrow purpose
    lda __distance_to_wall
    sbc multiplied_high_bits   ; perform subtraction on the LSBs
    sta __distance_to_wall
    lda __distance_to_wall+1
    sbc multiplied_high_bits+1 ; do the same for the MSBs, with carry set according to the previous result
    sta __distance_to_wall+1
    bra :+
    
add_sin_part_to_distance:
    ; __distance_to_wall = multiply_with_fraction(total_delta_x, cos_player_dir) + multiply_with_fraction(total_delta_y, sin_player_dir);
    ; __distance_to_wall = __distance_to_wall + multiply_with_fraction(total_delta_y, sin_player_dir);

    clc
    lda multiplied_high_bits
    adc __distance_to_wall
    sta __distance_to_wall   ; store sum of LSBs
    lda multiplied_high_bits+1
    adc __distance_to_wall+1  ; add the MSBs using carry from the previous calculation
    sta __distance_to_wall+1
:
    rts
    

; ==================================== Multiply with fraction ============================================

;multiply_with_fraction:

    ; Note: since we don't have floating point numbers, we use this special function to multiplie a 16-bit number 
    ; with a fraction (like 0.83 from a cosine). The 'fraction' is actually a number between 0 and (including) 256. 
    ; After the multiplication we divide by 256. This is to prevent overflow and/or to prevent loss of accuracy.
    ; Note: In this asm-version dealing with 256 (in the fraction) is done *outside* this function. It is applied in
    ; the function calculate_distance_to_wall.
    
    ; multiply_with_fraction:
    ;   high_bits = number >> 8;
    ;   low_bits = number & 0xFF;
    ;   multiplied_low_bits = low_bits * fraction;
    ;   multiplied_high_bits = high_bits * fraction;
    ;   high_bits_of_multiplied_low_bits = multiplied_low_bits >> 8;
    ;   multiplied_number = multiplied_high_bits + high_bits_of_multiplied_low_bits;

    ; Multiplication for 6502: http://nparker.llx.com/a2/mult.html
    ; Adding 16 bit + 8/16 bit: https://codebase64.org/doku.php?id=base:16bit_addition_and_subtraction
    
    ; multiplied_low_bits = low_bits * fraction;

;    lda #0           ; Initialize result to 0
;    ldx #8           ; There are 8 bits in fraction
;:   lsr low_bits     ; Get low bit of low_bits (by shifting it to the right)
;    bcc :+           ; Is lowest bit 0 or 1?
;    clc              ; If 1, add fraction
;    adc fraction
;:   ror a            ; "Stairstep" shift (catching carry from add)
;    ror multiplied_low_bits
;    dex
;    bne :--
;    sta multiplied_low_bits+1 ;
;
    ; multiplied_high_bits = high_bits * fraction

;    lda #0           ; Initialize result to 0
;    ldx #8           ; There are 8 bits in fraction
;:   lsr high_bits    ; Get low bit of high_bits (by shifting it to the right)
;    bcc :+           ; Is lowest bit 0 or 1?
;    clc              ; If 1, add fraction
;    adc fraction
;:   ror a            ; "Stairstep" shift (catching carry from add)
;    ror multiplied_high_bits
;    dex
;    bne :--
;    sta multiplied_high_bits+1 ; 
;
    ; multiplied_number = multiplied_high_bits + high_bits_of_multiplied_low_bits;
;
;    clc		
;    lda multiplied_high_bits    ; load the *low* byte of the multiplied_high_bits
;    adc multiplied_low_bits+1   ; add the *high* byte of the multiplied_low_bits
;    sta multiplied_high_bits    ; store it in the *low* byte of the multiplied_high_bits
;    bcc :+
;    inc multiplied_high_bits+1  ; if carry, then increment the *high* byte of the multiplied_high_bits by 1       
;:
;    rts


;.macro MultiplyWithFractionFast

;.endmacro

;multiply_with_fraction_fast:
    ; Table generation: I:0..511                                              
    ;                   square1_lo = <((I*I)/4)                               
    ;                   square1_hi = >((I*I)/4)                               
    ;                   square2_lo = <(((I-255)*(I-255))/4)                   
    ;                   square2_hi = >(((I-255)*(I-255))/4)                   
    
    ; fraction * low_bits  = AAaa                                        
    ; fraction * high_bits = BBbb                                        
    ;                                                         
    ;       AAaa                                              
    ;   + BBbb                                                
    ; ----------                                              
    ;   PRODUCT! (ignoring aa)

    ; FIXME ONLY Setup fraction if changed
    ; bcc :+
;        lda fraction+0
;        sta sm1a+1
;        sta sm3a+1
;        sta sm5a+1
;        sta sm7a+1
;        eor #$ff
;        sta sm2a+1
;        sta sm4a+1
;        sta sm6a+1
;        sta sm8a+1
    ; :

        ; Perform fraction * low_bits = AAaa
;        ldx low_bits
;        sec
;sm1a:   lda square1_lo,x
;sm2a:   sbc square2_lo,x
; TODO: we don't need aa: sta multiplied_low_bits+0
;sm3a:   lda square1_hi,x
;sm4a:   sbc square2_hi,x
;        sta _AA+1

        ; Perform fraction * high_bits = BBbb
;        ldx high_bits
;        sec
;sm5a:   lda square1_lo,x
;sm6a:   sbc square2_lo,x
;        sta _bb+1
;sm7a:   lda square1_hi,x
;sm8a:   sbc square2_hi,x
;        sta _BB+1

        ; Add the separate multiplications together
 ;       clc
;_AA:    lda #0       ; AA = multiplied_low_bits+1
;_bb:    adc #0       ; bb = multiplied_high_bits
;        sta multiplied_high_bits
; FIXME: can we remove the lda here and only do the adc?
;_BB:    lda #0       ; BB = multiplied_high_bits+1
;        adc #0       ; no cc, so 0 (but we need to add the carry)
;        sta multiplied_high_bits+1
;        
;        rts


distance_LO:        .byte 0
distance_HI:        .byte 0
wall_height:        .word 0
capped_wall_height: .word 0

generate_distance2height_tables:

    lda #0 
    sta distance_HI
    lda #0
    sta distance_LO
    
distance0_loop:
    LoadWord WALL_HEIGHT_NUMERATOR, dividend
    
    lda distance_HI
    sta divisor+1
    lda distance_LO
    sta divisor ; note: this is assumed to be the divisor already divided by 8
    
    jsr divide
    
    CopyWord divresult, wall_height
    CopyWord divresult, capped_wall_height
    
    ; Capped height to 511 is used to determining which precomputed code has to be run (if height is larger than render height, pixels have to be "stretched")
    CapWordTo511 wall_height

    ; Capped height to RENDER_HEIGHT is used for determining how many ceiling/floor pixels have to be drawn
    CapWordToConstantByte capped_wall_height, RENDER_HEIGHT

    ldx distance_LO
    lda wall_height
    sta distance2height0_LO,x
    lda wall_height+1
    sta distance2height0_HI,x
    lda capped_wall_height
    sta distance2height0_Capped,x
    
    inc distance_LO
    lda distance_LO
    bne distance0_loop

    ; ------------
    
    lda #1 
    sta distance_HI
    lda #0
    sta distance_LO
    
distance1_loop:
    LoadWord WALL_HEIGHT_NUMERATOR, dividend
    
    lda distance_HI
    sta divisor+1
    lda distance_LO
    sta divisor ; note: this is assumed to be the divisor already divided by 8
    
    jsr divide
    
    CopyWord divresult, wall_height
    CopyWord divresult, capped_wall_height
    
    ; Capped height to 511 is used to determining which precomputed code has to be run (if height is larger than render height, pixels have to be "stretched")
    CapWordTo511 wall_height

    ; Capped height to RENDER_HEIGHT is used for determining how many ceiling/floor pixels have to be drawn
    CapWordToConstantByte capped_wall_height, RENDER_HEIGHT

    ldx distance_LO
    lda wall_height
    sta distance2height1_LO,x
    lda wall_height+1
    sta distance2height1_HI,x
    lda capped_wall_height
    sta distance2height1_Capped,x
    
    inc distance_LO
    lda distance_LO
    bne distance1_loop
 
    rts

        
generate_multiplication_tables:

      ; Create first square table (I*I)/4
      ldx #$00
      txa
      .byte $c9   ; CMP #immediate - skip TYA and clear carry flag
lb1:  tya
      adc #$00
ml1:  sta square1_hi,x
      tay
      cmp #$40
      txa
      ror
ml9:  adc #$00
      sta ml9+1
      inx
ml0:  sta square1_lo,x
      bne lb1
      inc ml0+2
      inc ml1+2
      clc
      iny
      bne lb1        

      ; Create second square table ((I-255)*(I-255))/4
      ldx #$00
      ldy #$ff
:
      lda square1_hi+1,x
      sta square2_hi+$100,x
      lda square1_hi,x
      sta square2_hi,y
      lda square1_lo+1,x
      sta square2_lo+$100,x
      lda square1_lo,x
      sta square2_lo,y
      dey
      inx
      bne :-
      
      rts

; ================================================================================================
; ================================== DRAW VERTICAL BAR ===========================================
; ================================================================================================
    
__draw_vertical_bar:

    ; --- calculating ceiling height --- 
    lda #RENDER_HEIGHT
    sec
    sbc __capped_wall_height  ; RENDER_HEIGHT - wall_height
    lsr              ; ceiling_height = (RENDER_HEIGHT - wall_height) / 2
    sta ceiling_height

    ; --- calculating floor height --- 
    lda #RENDER_HEIGHT
    sec
    sbc __capped_wall_height  ; RENDER_HEIGHT - wall_height
    sec
    sbc ceiling_height  ; floor_height = RENDER_HEIGHT - wall_height - ceiling_height
    sta floor_height

    ; lda #<draw_240_pixels ; lower byte -> this is always $00
    ldx #2   ; we start at 240 * 3 instructions = 720 = 2*256 + 208
    lda #208
    sec
    sbc __capped_wall_height
    bcs :+   ; if carry is still set, we don't have to decrease x
    dex
:   sec
    sbc __capped_wall_height
    bcs :+   ; if carry is still set, we don't have to decrease x
    dex
:   sec
    sbc __capped_wall_height
    bcs :+   ; if carry is still set, we don't have to decrease x
    dex
:   sta wall_low
    txa
    clc
    adc #>draw_240_pixels ; we add 0-2 to higher byte
    sta wall_hi

    ; lda #<draw_240_pixels ; lower byte -> this is always $00
    ldx #2   ; we start at 240 * 3 instructions = 720 = 2*256 + 208
    lda #208
    sec
    sbc ceiling_height
    bcs :+   ; if carry is still set, we don't have to decrease x
    dex
:   sec
    sbc ceiling_height
    bcs :+   ; if carry is still set, we don't have to decrease x
    dex
:   sec
    sbc ceiling_height
    bcs :+   ; if carry is still set, we don't have to decrease x
    dex
:   sta ceiling_low
    txa
    clc
    adc #>draw_240_pixels ; we add 0-2 to higher byte
    sta ceiling_hi
    
    ; lda #<draw_240_pixels ; lower byte -> this is always $00
    ldx #2   ; we start at 240 * 3 instructions = 720 = 2*256 + 208
    lda #208
    sec
    sbc floor_height
    bcs :+   ; if carry is still set, we don't have to decrease x
    dex
:   sec
    sbc floor_height
    bcs :+   ; if carry is still set, we don't have to decrease x
    dex
:   sec
    sbc floor_height
    bcs :+   ; if carry is still set, we don't have to decrease x
    dex
:   sta floor_low
    txa
    clc
    adc #>draw_240_pixels ; we add 0-2 to higher byte
    sta floor_hi
    
    
    ; setup start address in VRAM
    lda #<RENDER_BASE
    clc
    adc __pixel_column
    sta VERA_addr_low
    
    lda #>RENDER_BASE
    ; clc               ; TODO: we are adding 16 bits, so we shouldnt reset the carry here, probably remove it.
    adc __pixel_column+1   ; we add the HI byte to the base tile address
    sta VERA_addr_high
    
    lda #%11100000      ; setting bit 16 of vram address to the highest bit in the tilebase (=0), setting auto-increment value to 320 (note: 14=320)
    sta VERA_addr_bank
    
    ; draw the ceiling

    lda ceiling_low
    sta jump_address
    lda ceiling_hi
    sta jump_address+1
    
    lda #CEILING_COLOR
    jsr do_the_jumping
    
    ; draw the wall

    ; Here we choose to draw textures or plain colors
    lda __use_textures
    cmp #1
    beq draw_texture

    lda wall_low
    sta jump_address
    lda wall_hi
    sta jump_address+1
    lda __color_to_draw   ; This is the color to draw (if you don't pick a color from a texture)
    jsr do_the_jumping
    jmp draw_floor
   
draw_texture:

    ; First setup VERA texture reading (useing VERA1 address/data)
    
    ; _RAM_BANK = wall_height/8;
    
    lda __wall_height+1 ; high byte of wall_height
    lsr                ; we shift the high byte one to the right (of the lowest bit of the high byte is 1, its now in the carry)
    lda __wall_height
    ror                ; we rotate the low byte one to the right (so the lowest bit of the high byte is now the highest bit of the low byte) (= wall_height/2)
    lsr                ; we shift again (= wall_height/4)
    lsr                ; we shift again (= wall_height/8)
    sta __RAM_BANK      ; we set the RAM_BANK to this value
    
    ; _sub_bank = wall_height % 8;
    lda __wall_height  ; low byte of wall_height
    and #7
    sta __sub_bank    ; use lower 3 bits as sub_bank (0-7)


    lda #1
    sta VERA_control   ; ADDRSEL=1

    lda #$71
    sta VERA_addr_bank ; setting bit 16 of vram address to the highest bit in the tilebase (=1), setting auto-increment value to 64 (7=64)
    
    ; FIXME: for now we do tile_value * 16 so we choose the correct VERA address for the texture. This should be done in the map itself!
    lda __color_to_draw
    cmp #5          ; TODO: right now, texture 5 is a special case. if we hit a vertical wall we make it texture 1
    bne :+
    ldx __hit_vertical_wall
    beq :+          ; if we didn't hit a vertical wall (but a horizontal one) we don't change the texture, otherwise we go back to texture 1
    lda #1
: 
    asl
    asl
    asl
    asl
    ; FIXME: we now do -4096 to make sure that texture number 1 will be at address $18C00 + $0000 (and not $18C00 + $1000)
    clc
    adc #>(TEXTURES_VRAM_BASE-4096)           ; base address for texture now is $18C00, right behind the BITMAP memory
    sta VERA_addr_high

    lda __hit_point_on_wall
    lsr
    lsr                ; hit_point_on_wall is 0-255, but we have a texture of 64 wide. So we divide by 4.
    sta VERA_addr_low    
    
    lda #0
    sta VERA_control   ; ADDRSEL=0

    ldx #0
    cpx __sub_bank
    bne :+
    jsr __banked_draw_code
:   ldx #1
    cpx __sub_bank
    bne :+
    jsr __banked_draw_code1
:   ldx #2
    cpx __sub_bank
    bne :+
    jsr __banked_draw_code2
:   ldx #3
    cpx __sub_bank
    bne :+
    jsr __banked_draw_code3
:   ldx #4
    cpx __sub_bank
    bne :+
    jsr __banked_draw_code4
:   ldx #5
    cpx __sub_bank
    bne :+
    jsr __banked_draw_code5
:   ldx #6
    cpx __sub_bank
    bne :+
    jsr __banked_draw_code6
:   ldx #7
    cpx __sub_bank
    bne :+
    jsr __banked_draw_code7
:    

draw_floor:
    ; draw the floor
    
    lda floor_low
    sta jump_address
    lda floor_hi
    sta jump_address+1
    
    lda #FLOOR_COLOR
    jsr do_the_jumping

    rts

do_the_jumping:
    jmp (jump_address)
;    rts ; this rts will never be reached, since in the jumped code there will be an rts
    
    
; ================================================================================================
; ==================================== INIT DRAW CODE ============================================
; ================================================================================================

__init_draw_code:

    ; TODO: maybe we want to call this separately from c
    jsr generate_multiplication_tables
    jsr generate_distance2height_tables

    lda ZP_PTR_4
    sta ZP_PTR_4_BACKUP
    lda ZP_PTR_4+1
    sta ZP_PTR_4_BACKUP+1

    lda #<draw_240_pixels
    sta ZP_PTR_4
    lda #>draw_240_pixels
    sta ZP_PTR_4+1
    
    ldy #0                 ; generated code byte counter
    
    ldx #0                 ; counts nr of "sta $9F23" instructions

nextInstruction:

    ; -- sta VERA_data0 ($9F23)
    lda #$8D               ; sta ....
    jsr addCodeByte

    lda #$23               ; $23
    jsr addCodeByte
    
    lda #$9F               ; $9F
    jsr addCodeByte

    inx
    cpx #240    
    bne nextInstruction
    
    ; -- rts --
    lda #$60
    jsr addCodeByte

    lda ZP_PTR_4_BACKUP
    sta ZP_PTR_4
    lda ZP_PTR_4_BACKUP+1
    sta ZP_PTR_4+1
    
    rts

addCodeByte:
    sta (ZP_PTR_4),y       ; store code byte at address (located at ZP_PTR_4) + y
    iny                    ; increase y
    cpy #0                 ; if y == 0
    bne :+
    inc ZP_PTR_4+1         ; increment high-byte of ZP_PTR_4
:   rts


; ================================================================================================
; ============================= GENERATE TEXTURE DRAW CODE =======================================
; ================================================================================================

nth_pixel:                  .byte 0
y_texture_pixel:            .word 0
previous_y_texture_pixel:   .byte 0
nr_of_loads_to_add:         .byte 0
wall_height_outside_render: .word 0
temp_y:                     .byte 0

__generate_texture_draw_code:

    lda ZP_PTR_4
    sta ZP_PTR_4_BACKUP
    lda ZP_PTR_4+1
    sta ZP_PTR_4_BACKUP+1

    lda #0
    sta __wall_height+1
    lda #8
    sta __wall_height
    
next_wall_height:
    
        CopyWord __wall_height, __capped_wall_height
        CapWordToConstantByte __capped_wall_height, RENDER_HEIGHT
        
        ; The difference between the wall_height and the capped_wall_height is the height outside the rendering height
        SubtractWordFromWord __wall_height, __capped_wall_height, wall_height_outside_render
        ; We only want the top part of this height so we divide it by 2 (shift to right). ;
        ; TODO: this assumes that height is not >= 512. Is this always the case? (we are ignoring the high byte here)
        lsr wall_height_outside_render
        
        ; _RAM_BANK = wall_height/8
        
        lda __wall_height+1 ; high byte of wall_height
        lsr                ; we shift the high byte one to the right (of the lowest bit of the high byte is 1, its now in the carry)
        lda __wall_height
        ror                ; we rotate the low byte one to the right (so the lowest bit of the high byte is now the highest bit of the low byte) (= wall_height/2)
        lsr                ; we shift again (= wall_height/4)
        lsr                ; we shift again (= wall_height/8)

        sta __RAM_BANK     ; we set the RAM_BANK to this value
        
        ; byte_code_index = (height%8) * 1024; // sub bank = 1024 bytes
        
        lda __wall_height  ; low byte of wall_height
        and #7
        asl
        asl                ; we put this in the high byte (= *256) and do it times 4 (shift to the left) = * 1024
        clc
        adc #$A0           ; Base bank address = $A000
        sta ZP_PTR_4+1

        lda #0
        sta ZP_PTR_4       ; low byte is $00
        
        ldy #0             ; generated code byte counter

        ; We assume we always load at least once.
        
        lda #$AD           ; lda ....
        jsr addCodeByte
        lda #$24           ; VERA_DATA1
        jsr addCodeByte
        lda #$9F         
        jsr addCodeByte
    
        ; We compare with previous_y_texture_pixel to check whether we should add loads. We start at 0 (not -1) because we always load at least once (see above)
        lda #0
        sta previous_y_texture_pixel
    
        ; nth_pixel = nth pixel of wall on screen 
        
        lda #0
        sta nth_pixel
        
next_wall_pixel:        
        ; y_texture_pixel = pick_texture_pixel_row(n, capped_height, height);
        ; y_texture_pixel = ((n + (height - capped_height)/2) * 64) / height
        ; y_texture_pixel = ((n + wall_height_outside_render) * 64) / height
        
        AddByteToByteIntoWord nth_pixel, wall_height_outside_render, y_texture_pixel
        MultiplyWordBy64 y_texture_pixel

        ;  y_texture_pixel = y_texture_pixel / __wall_height
        CopyWord y_texture_pixel, dividend  ; note: dividend is also used for storing the divresult
        CopyWord __wall_height, divisor
        ; TODO: workaround for y being used by 'divide'
        sty temp_y
        jsr divide  ; FIXME: this should be put inline using a macro! Do not copy all these 16-bit values!
        ldy temp_y
        
        ; TODO: this copy should not be needed, but we need to do it for now
        CopyWord divresult, y_texture_pixel

        lda y_texture_pixel
        cmp previous_y_texture_pixel
        bne :+
        
        ; Case: y_texture_pixel == previous_y_texture_pixel
        
        ; No need to load, since we have to store using the same data as before
        lda #$8D         ; sta ....
        jsr addCodeByte
        lda #$23         ; VERA_DATA0
        jsr addCodeByte
        lda #$9F         
        jsr addCodeByte
        
        bra continue_wall_pixel
:
        ; Case: y_pixel > previous_y_pixel (technically y_pixel != previous_y_pixel, but y_pixel < previous_y_pixel should never happen)
        
        ; nr_of_loads_to_add = y_pixel - previous_y_pixel;
        SubtractByteFromByte y_texture_pixel, previous_y_texture_pixel, nr_of_loads_to_add

; TODO: not needed        lda nr_of_loads_to_add
next_load_to_add:
            lda #$AD           ; lda ....
            jsr addCodeByte
            lda #$24           ; VERA_DATA1
            jsr addCodeByte
            lda #$9F         
            jsr addCodeByte
        
        dec nr_of_loads_to_add
        bne next_load_to_add
        
        lda #$8D         ; sta ....
        jsr addCodeByte
        lda #$23         ; VERA_DATA0
        jsr addCodeByte
        lda #$9F         
        jsr addCodeByte
        
continue_wall_pixel:
        lda y_texture_pixel
        sta previous_y_texture_pixel
        
        inc nth_pixel
        lda nth_pixel
        cmp __capped_wall_height
        beq :+
        jmp next_wall_pixel
:
        ; -- rts --
        lda #$60
        jsr addCodeByte

        jsr draw_progress_piece
    
    inc __wall_height
    bne :+                ; if we reach 256 or 512 we should increment the high byte (otherwise not)
    inc __wall_height+1
    lda __wall_height+1
    cmp #2                ; if we reach $0200 then we should stop generating draw code (we have done until 511)
    beq :++
:
    jmp next_wall_height
:

    lda ZP_PTR_4_BACKUP
    sta ZP_PTR_4
    lda ZP_PTR_4_BACKUP+1
    sta ZP_PTR_4+1
    
    rts

; ================================== Draw progress piece ==========================================

progress_piece_index:   .word 0

draw_progress_piece:

    CopyWord __wall_height, progress_piece_index
    
    lsr progress_piece_index+1   ; number between 8 and 511
    ror progress_piece_index     ; number between 4 and 255
    dec progress_piece_index
    dec progress_piece_index     ; number between 2 and 253
    
    ; setup start address in VRAM
    lda #<(RENDER_BASE+(SCREEN_WIDTH*87)+(RENDER_WIDTH - 256)/2)
    clc
    adc progress_piece_index
    sta VERA_addr_low
    
    lda #>(RENDER_BASE+(SCREEN_WIDTH*87)+(RENDER_WIDTH - 256)/2)
    adc progress_piece_index+1   ; we add the HI byte to the base tile address
    sta VERA_addr_high
    
    lda #%11100000      ; setting bit 16 of vram address to the highest bit in the tilebase (=0), setting auto-increment value to 320 (note: 14=320)
    sta VERA_addr_bank

    lda #2  ; TODO: hardcoded color 
    sta VERA_data0 ; TODO: hardcoded hieght of progress bar
    sta VERA_data0
    sta VERA_data0
    sta VERA_data0

    rts

; ===================================== V-sync counter ============================================

; Note: I used some of SlithyMatt code (about his 'stopwatch') below and modified it.
default_irq_vector: .addr 0
__ticks: .byte 0

__enable_vsync_counter:

   ; backup default RAM IRQ vector
   lda IRQVec
   sta default_irq_vector
   lda IRQVec+1
   sta default_irq_vector+1

   ; overwrite RAM IRQ vector with custom handler address
   sei ; disable IRQ while vector is changing
   lda #<custom_irq_handler
   sta IRQVec
   lda #>custom_irq_handler
   sta IRQVec+1
   lda #VSYNC_BIT ; make VERA only generate VSYNC IRQs
   sta VERA_ien
   cli ; enable IRQ now that vector is properly set
   
   stz __ticks  ; start ticks at 0

   rts
   
custom_irq_handler:
   lda VERA_isr
   and #VSYNC_BIT
   beq @continue ; non-VSYNC IRQ, no tick update
   lda __ticks
   inc
   sta __ticks ; ticks incremented
@continue:
   jmp (default_irq_vector) ; continue to default IRQ handler
